Index: test/max_flow_test.cc
===================================================================
--- test/max_flow_test.cc	(revision 1178)
+++ test/max_flow_test.cc	(revision 1092)
@@ -27,5 +27,4 @@
 #include <lemon/lgf_reader.h>
 #include <lemon/elevator.h>
-#include <lemon/tolerance.h>
 
 using namespace lemon;
@@ -67,35 +66,4 @@
   "target 8\n";
 
-char test_lgf_float[] =
-  "@nodes\n"
-  "label\n"
-  "0\n"
-  "1\n"
-  "2\n"
-  "3\n"
-  "4\n"
-  "5\n"
-  "6\n"
-  "7\n"
-  "8\n"
-  "9\n"
-  "@arcs\n"
-  "      capacity\n"
-  "0 1 0.1\n"
-  "0 2 0.1\n"
-  "0 3 0.1\n"
-  "1 4 0.1\n"
-  "2 4 0.1\n"
-  "3 4 0.1\n"
-  "4 5 0.3\n"
-  "5 6 0.1\n"
-  "5 7 0.1\n"
-  "5 8 0.1\n"
-  "6 9 0.1\n"
-  "7 9 0.1\n"
-  "8 9 0.1\n"
-  "@attributes\n"
-  "source 0\n"
-  "target 9\n";
 
 // Checks the general interface of a max flow algorithm
@@ -198,4 +166,6 @@
   typedef concepts::Digraph Digraph;
   typedef concepts::ReadMap<Digraph::Arc, Value> CapMap;
+  typedef Elevator<Digraph, Digraph::Node> Elev;
+  typedef LinkedElevator<Digraph, Digraph::Node> LinkedElev;
 
   Digraph g;
@@ -215,11 +185,11 @@
 
 template <typename T>
-T cutValue(const SmartDigraph& g,
-           const SmartDigraph::NodeMap<bool>& cut,
-           const SmartDigraph::ArcMap<T>& cap) {
-
-  T c = 0;
-  for (SmartDigraph::ArcIt e(g); e != INVALID; ++e) {
-    if (cut[g.source(e)] && !cut[g.target(e)]) c += cap[e];
+T cutValue (const SmartDigraph& g,
+              const SmartDigraph::NodeMap<bool>& cut,
+              const SmartDigraph::ArcMap<T>& cap) {
+
+  T c=0;
+  for(SmartDigraph::ArcIt e(g); e!=INVALID; ++e) {
+    if (cut[g.source(e)] && !cut[g.target(e)]) c+=cap[e];
   }
   return c;
@@ -230,9 +200,8 @@
                const SmartDigraph::ArcMap<T>& flow,
                const SmartDigraph::ArcMap<T>& cap,
-               SmartDigraph::Node s, SmartDigraph::Node t,
-               const Tolerance<T>& tol) {
+               SmartDigraph::Node s, SmartDigraph::Node t) {
 
   for (SmartDigraph::ArcIt e(g); e != INVALID; ++e) {
-    if (tol.negative(flow[e]) || tol.less(cap[e], flow[e])) return false;
+    if (flow[e] < 0 || flow[e] > cap[e]) return false;
   }
 
@@ -246,27 +215,26 @@
       sum -= flow[e];
     }
-    if (tol.nonZero(sum)) return false;
+    if (sum != 0) return false;
   }
   return true;
 }
 
-void checkInitPreflow()
+void initFlowTest()
 {
   DIGRAPH_TYPEDEFS(SmartDigraph);
 
   SmartDigraph g;
-  SmartDigraph::ArcMap<int> cap(g), iflow(g);
-  Node s = g.addNode(); Node t = g.addNode();
-  Node n1 = g.addNode(); Node n2 = g.addNode();
+  SmartDigraph::ArcMap<int> cap(g),iflow(g);
+  Node s=g.addNode(); Node t=g.addNode();
+  Node n1=g.addNode(); Node n2=g.addNode();
   Arc a;
-  a = g.addArc(s, n1); cap[a] = 20; iflow[a] = 20;
-  a = g.addArc(n1, n2); cap[a] = 10; iflow[a] = 0;
-  a = g.addArc(n2, t); cap[a] = 20; iflow[a] = 0;
-
-  Preflow<SmartDigraph> pre(g, cap, s, t);
+  a=g.addArc(s,n1); cap[a]=20; iflow[a]=20;
+  a=g.addArc(n1,n2); cap[a]=10; iflow[a]=0;
+  a=g.addArc(n2,t); cap[a]=20; iflow[a]=0;
+
+  Preflow<SmartDigraph> pre(g,cap,s,t);
   pre.init(iflow);
   pre.startFirstPhase();
-
-  check(pre.flowValue() == 10, "Incorrect max flow value.");
+  check(pre.flowValue() == 10, "The incorrect max flow value.");
   check(pre.minCut(s), "Wrong min cut (Node s).");
   check(pre.minCut(n1), "Wrong min cut (Node n1).");
@@ -276,5 +244,5 @@
 
 template <typename MF, typename SF>
-void checkMaxFlowAlg(const char *input_lgf,  typename MF::Value expected) {
+void checkMaxFlowAlg() {
   typedef SmartDigraph Digraph;
   DIGRAPH_TYPEDEFS(Digraph);
@@ -285,14 +253,12 @@
   typedef BoolNodeMap CutMap;
 
-  Tolerance<Value> tol;
-
   Digraph g;
   Node s, t;
   CapMap cap(g);
-  std::istringstream input(input_lgf);
-  DigraphReader<Digraph>(g, input)
+  std::istringstream input(test_lgf);
+  DigraphReader<Digraph>(g,input)
       .arcMap("capacity", cap)
-      .node("source", s)
-      .node("target", t)
+      .node("source",s)
+      .node("target",t)
       .run();
 
@@ -300,7 +266,5 @@
   max_flow.run();
 
-  check(!tol.different(expected, max_flow.flowValue()),
-        "Incorrect max flow value.");
-  check(checkFlow(g, max_flow.flowMap(), cap, s, t, tol),
+  check(checkFlow(g, max_flow.flowMap(), cap, s, t),
         "The flow is not feasible.");
 
@@ -309,10 +273,13 @@
   Value min_cut_value = cutValue(g, min_cut, cap);
 
-  check(!tol.different(expected, min_cut_value),
-        "Incorrect min cut value.");
+  check(max_flow.flowValue() == min_cut_value,
+        "The max flow value is not equal to the min cut value.");
 
   FlowMap flow(g);
-  for (ArcIt e(g); e != INVALID; ++e) flow[e] = 13 * max_flow.flowMap()[e];
-  for (ArcIt e(g); e != INVALID; ++e) cap[e] = 17 * cap[e];
+  for (ArcIt e(g); e != INVALID; ++e) flow[e] = max_flow.flowMap()[e];
+
+  Value flow_value = max_flow.flowValue();
+
+  for (ArcIt e(g); e != INVALID; ++e) cap[e] = 2 * cap[e];
   max_flow.init(flow);
 
@@ -323,12 +290,11 @@
   min_cut_value = cutValue(g, min_cut1, cap);
 
-  check(!tol.different(17 * expected, max_flow.flowValue()),
-        "Incorrect max flow value.");
-  check(!tol.different(17 * expected, min_cut_value),
-        "Incorrect min cut value.");
+  check(max_flow.flowValue() == min_cut_value &&
+        min_cut_value == 2 * flow_value,
+        "The max flow value or the min cut value is wrong.");
 
   SF::startSecondPhase(max_flow);       // start second phase of the algorithm
 
-  check(checkFlow(g, max_flow.flowMap(), cap, s, t, tol),
+  check(checkFlow(g, max_flow.flowMap(), cap, s, t),
         "The flow is not feasible.");
 
@@ -337,8 +303,8 @@
   min_cut_value = cutValue(g, min_cut2, cap);
 
-  check(!tol.different(17 * expected, max_flow.flowValue()),
-        "Incorrect max flow value.");
-  check(!tol.different(17 * expected, min_cut_value),
-        "Incorrect min cut value.");
+  check(max_flow.flowValue() == min_cut_value &&
+        min_cut_value == 2 * flow_value,
+        "The max flow value or the min cut value was not doubled");
+
 
   max_flow.flowMap(flow);
@@ -359,7 +325,7 @@
   CutMap min_cut3(g);
   max_flow.minCutMap(min_cut3);
-  min_cut_value = cutValue(g, min_cut3, cap);
-
-  check(!tol.different(max_flow.flowValue(), min_cut_value),
+  min_cut_value=cutValue(g, min_cut3, cap);
+
+  check(max_flow.flowValue() == min_cut_value,
         "The max flow value or the min cut value is wrong.");
 }
@@ -414,26 +380,15 @@
   typedef Preflow<SmartDigraph, SmartDigraph::ArcMap<int> > PType1;
   typedef Preflow<SmartDigraph, SmartDigraph::ArcMap<float> > PType2;
-  typedef Preflow<SmartDigraph, SmartDigraph::ArcMap<double> > PType3;
-
-  checkMaxFlowAlg<PType1, PreflowStartFunctions<PType1> >(test_lgf, 13);
-  checkMaxFlowAlg<PType2, PreflowStartFunctions<PType2> >(test_lgf, 13);
-  checkMaxFlowAlg<PType3, PreflowStartFunctions<PType3> >(test_lgf, 13);
-
-  checkMaxFlowAlg<PType2, PreflowStartFunctions<PType2> >(test_lgf_float, 0.3f);
-  checkMaxFlowAlg<PType3, PreflowStartFunctions<PType3> >(test_lgf_float, 0.3);
-
-  checkInitPreflow();
+  checkMaxFlowAlg<PType1, PreflowStartFunctions<PType1> >();
+  checkMaxFlowAlg<PType2, PreflowStartFunctions<PType2> >();
+  initFlowTest();
 
   // Check EdmondsKarp
   typedef EdmondsKarp<SmartDigraph, SmartDigraph::ArcMap<int> > EKType1;
   typedef EdmondsKarp<SmartDigraph, SmartDigraph::ArcMap<float> > EKType2;
-  typedef EdmondsKarp<SmartDigraph, SmartDigraph::ArcMap<double> > EKType3;
-
-  checkMaxFlowAlg<EKType1, GeneralStartFunctions<EKType1> >(test_lgf, 13);
-  checkMaxFlowAlg<EKType2, GeneralStartFunctions<EKType2> >(test_lgf, 13);
-  checkMaxFlowAlg<EKType3, GeneralStartFunctions<EKType3> >(test_lgf, 13);
-
-  checkMaxFlowAlg<EKType2, GeneralStartFunctions<EKType2> >(test_lgf_float, 0.3f);
-  checkMaxFlowAlg<EKType3, GeneralStartFunctions<EKType3> >(test_lgf_float, 0.3);
+  checkMaxFlowAlg<EKType1, GeneralStartFunctions<EKType1> >();
+  checkMaxFlowAlg<EKType2, GeneralStartFunctions<EKType2> >();
+
+  initFlowTest();
 
   return 0;
Index: test/planarity_test.cc
===================================================================
--- test/planarity_test.cc	(revision 1182)
+++ test/planarity_test.cc	(revision 798)
@@ -31,36 +31,6 @@
 using namespace lemon::dim2;
 
-const int lgfn = 8;
+const int lgfn = 4;
 const std::string lgf[lgfn] = {
-  "@nodes\n"
-  "label\n"
-  "@edges\n"
-  "     label\n",
-
-  "@nodes\n"
-  "label\n"
-  "0\n"
-  "@edges\n"
-  "     label\n",
-
-  "@nodes\n"
-  "label\n"
-  "0\n"
-  "1\n"
-  "@edges\n"
-  "     label\n"
-  "0 1  0\n",
-
-  "@nodes\n"
-  "label\n"
-  "0\n"
-  "1\n"
-  "2\n"
-  "@edges\n"
-  "     label\n"
-  "0 1  0\n"
-  "1 2  1\n"
-  "2 0  2\n",
-
   "@nodes\n"
   "label\n"
@@ -167,9 +137,6 @@
     }
   }
-
-  if (face_num != 0) {
-    check(face_num + countNodes(graph) - countConnectedComponents(graph) ==
-          countEdges(graph) + 1, "Euler test does not passed");
-  }
+  check(face_num + countNodes(graph) - countConnectedComponents(graph) ==
+        countEdges(graph) + 1, "Euler test does not passed");
 }
 
@@ -279,27 +246,11 @@
       checkEmbedding(graph, pe);
 
-      {
-        PlanarDrawing<Graph> pd(graph);
-        pd.run(pe.embeddingMap());
-        checkDrawing(graph, pd);
-      }
-
-      {
-        PlanarDrawing<Graph> pd(graph);
-        pd.run();
-        checkDrawing(graph, pd);
-      }
-
-      {
-        PlanarColoring<Graph> pc(graph);
-        pc.runFiveColoring(pe.embeddingMap());
-        checkColoring(graph, pc, 5);
-      }
-
-      {
-        PlanarColoring<Graph> pc(graph);
-        pc.runFiveColoring();
-        checkColoring(graph, pc, 5);
-      }
+      PlanarDrawing<Graph> pd(graph);
+      pd.run(pe.embeddingMap());
+      checkDrawing(graph, pd);
+
+      PlanarColoring<Graph> pc(graph);
+      pc.runFiveColoring(pe.embeddingMap());
+      checkColoring(graph, pc, 5);
 
     } else {
Index: test/random_test.cc
===================================================================
--- test/random_test.cc	(revision 1163)
+++ test/random_test.cc	(revision 440)
@@ -22,31 +22,4 @@
 int seed_array[] = {1, 2};
 
-int rnd_seq32[] = {
-2732, 43567, 42613, 52416, 45891, 21243, 30403, 32103, 
-62501, 33003, 12172, 5192, 32511, 50057, 43723, 7813, 
-23720, 35343, 6637, 30280, 44566, 31019, 18898, 33867, 
-5994, 1688, 11513, 59011, 48056, 25544, 39168, 25365, 
-17530, 8366, 27063, 49861, 55169, 63848, 11863, 49608
-};
-int rnd_seq64[] = {
-56382, 63883, 59577, 64750, 9644, 59886, 57647, 18152, 
-28520, 64078, 17818, 49294, 26424, 26697, 53684, 19209, 
-35404, 12121, 12837, 11827, 32156, 58333, 62553, 7907, 
-64427, 39399, 21971, 48789, 46981, 15716, 53335, 65256, 
-12999, 15308, 10906, 42162, 47587, 43006, 53921, 18716
-};
-
-void seq_test() {
-  for(int i=0;i<5;i++) {
-    lemon::Random32 r32(i);
-    lemon::Random64 r64(i);
-    for(int j=0;j<8;j++) {
-      check(r32[65536]==rnd_seq32[i*8+j], "Wrong random sequence");
-      check(r64[65536]==rnd_seq64[i*8+j], "Wrong random sequence");
-    }
-  }
-}
-
-
 int main()
 {
@@ -64,5 +37,4 @@
                   (sizeof(seed_array) / sizeof(seed_array[0])));
 
-  seq_test();
   return 0;
 }
Index: test/vf2_test.cc
===================================================================
--- test/vf2_test.cc	(revision 1143)
+++ test/vf2_test.cc	(revision 1186)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2015
+ * Copyright (C) 2015-2017
  * EMAXA Kutato-fejleszto Kft. (EMAXA Research Ltd.)
  *
@@ -184,5 +184,7 @@
 class EqComparable {
 public:
-  bool operator==(const EqComparable&) { return false; }
+  bool operator==(const EqComparable&) {
+    return false;
+  }
 };
 
@@ -190,10 +192,11 @@
 class EqClass {
 public:
-  bool operator()(A, B) { return false; }
+  bool operator()(A, B){
+    return false;
+  }
 };
 
 template<class G1,class G2>
-void checkVf2Compile()
-{
+void checkVf2Compile() {
   G1 g;
   G2 h;
@@ -206,6 +209,13 @@
   succ = vf2(g,h).iso().run();
   succ = vf2(g,h).mapping(r).run();
+
+  Vf2<G1,G2,concepts::ReadWriteMap<typename G1::Node, typename G2::Node>,
+      EqClass<typename G1::Node,typename G2::Node> >
+    myVf2(g,h,r,EqClass<typename G1::Node,typename G2::Node>());
+  myVf2.find();
+
   succ = vf2(g,h).induced().mapping(r).run();
   succ = vf2(g,h).iso().mapping(r).run();
+
   concepts::ReadMap<typename G1::Node, EqComparable> l1;
   concepts::ReadMap<typename G2::Node, EqComparable> l2;
@@ -215,6 +225,5 @@
 }
 
-void justCompile()
-{
+void justCompile() {
   checkVf2Compile<concepts::Graph,concepts::Graph>();
   checkVf2Compile<concepts::Graph,SmartGraph>();
@@ -223,14 +232,12 @@
 
 template<class G1, class G2, class I>
-void checkSub(const G1 &g1, const G2 &g2, const I &i)
-{
+void checkSub(const G1 &g1, const G2 &g2, const I &i) {
   {
     std::set<typename G2::Node> image;
-    for(typename G1::NodeIt n(g1);n!=INVALID;++n)
-      {
-          check(i[n]!=INVALID, "Wrong isomorphism: incomplete mapping.");
-          check(image.count(i[n])==0,"Wrong isomorphism: not injective.");
-          image.insert(i[n]);
-      }
+    for(typename G1::NodeIt n(g1);n!=INVALID;++n){
+      check(i[n]!=INVALID, "Wrong isomorphism: incomplete mapping.");
+      check(image.count(i[n])==0,"Wrong isomorphism: not injective.");
+      image.insert(i[n]);
+    }
   }
   for(typename G1::EdgeIt e(g1);e!=INVALID;++e)
@@ -240,85 +247,76 @@
 
 template<class G1, class G2, class I>
-void checkInd(const G1 &g1, const G2 &g2, const I &i)
-  {
+void checkInd(const G1 &g1, const G2 &g2, const I &i) {
   std::set<typename G2::Node> image;
-  for(typename G1::NodeIt n(g1);n!=INVALID;++n)
-    {
+  for(typename G1::NodeIt n(g1);n!=INVALID;++n) {
     check(i[n]!=INVALID, "Wrong isomorphism: incomplete mapping.");
     check(image.count(i[n])==0,"Wrong isomorphism: not injective.");
     image.insert(i[n]);
-    }
+  }
   for(typename G1::NodeIt n(g1); n!=INVALID; ++n)
     for(typename G1::NodeIt m(g1); m!=INVALID; ++m)
-      if((findEdge(g1,n,m)==INVALID) != (findEdge(g2,i[n],i[m])==INVALID))
-        {
+      if((findEdge(g1,n,m)==INVALID) != (findEdge(g2,i[n],i[m])==INVALID)) {
         std::cout << "Wrong isomorphism: edge mismatch";
         exit(1);
-        }
-  }
+      }
+}
 
 template<class G1,class G2>
-int checkSub(const G1 &g1, const G2 &g2)
-{
+int checkSub(const G1 &g1, const G2 &g2) {
   typename G1:: template NodeMap<typename G2::Node> iso(g1,INVALID);
-  if(vf2(g1,g2).mapping(iso).run())
-    {
-      checkSub(g1,g2,iso);
-      return true;
-    }
-  else return false;
+  if(vf2(g1,g2).mapping(iso).run()) {
+    checkSub(g1,g2,iso);
+    return true;
+  }
+  else
+    return false;
 }
 
 template<class G1,class G2>
-int checkInd(const G1 &g1, const G2 &g2)
-{
+int checkInd(const G1 &g1, const G2 &g2) {
   typename G1:: template NodeMap<typename G2::Node> iso(g1,INVALID);
-  if(vf2(g1,g2).induced().mapping(iso).run())
-    {
-      checkInd(g1,g2,iso);
-      return true;
-    }
-  else return false;
+  if(vf2(g1,g2).induced().mapping(iso).run()) {
+    checkInd(g1,g2,iso);
+    return true;
+  }
+  else
+    return false;
 }
 
 template<class G1,class G2>
-int checkIso(const G1 &g1, const G2 &g2)
-{
+int checkIso(const G1 &g1, const G2 &g2) {
   typename G1:: template NodeMap<typename G2::Node> iso(g1,INVALID);
-  if(vf2(g1,g2).iso().mapping(iso).run())
-    {
-      check(countNodes(g1)==countNodes(g2),
-            "Wrong iso alg.: they are not isomophic.");
-      checkInd(g1,g2,iso);
-      return true;
-    }
-  else return false;
+  if(vf2(g1,g2).iso().mapping(iso).run()) {
+    check(countNodes(g1)==countNodes(g2),
+          "Wrong iso alg.: they are not isomophic.");
+    checkInd(g1,g2,iso);
+    return true;
+  }
+  else
+    return false;
 }
 
 template<class G1, class G2, class L1, class L2, class I>
 void checkLabel(const G1 &g1, const G2 &,
-                const L1 &l1, const L2 &l2,const I &i)
-{
+                const L1 &l1, const L2 &l2,const I &i) {
   for(typename G1::NodeIt n(g1);n!=INVALID;++n)
-    {
-      check(l1[n]==l2[i[n]],"Wrong isomorphism: label mismatch.");
-    }
+    check(l1[n]==l2[i[n]],"Wrong isomorphism: label mismatch.");
 }
 
 template<class G1,class G2,class L1,class L2>
-int checkSub(const G1 &g1, const G2 &g2, const L1 &l1, const L2 &l2)
-{
+int checkSub(const G1 &g1, const G2 &g2, const L1 &l1, const L2 &l2) {
   typename G1:: template NodeMap<typename G2::Node> iso(g1,INVALID);
-  if(vf2(g1,g2).nodeLabels(l1,l2).mapping(iso).run())
-    {
-      checkSub(g1,g2,iso);
-      checkLabel(g1,g2,l1,l2,iso);
-      return true;
-    }
-  else return false;
+  if(vf2(g1,g2).nodeLabels(l1,l2).mapping(iso).run()){
+    checkSub(g1,g2,iso);
+    checkLabel(g1,g2,l1,l2,iso);
+    return true;
+  }
+  else
+    return false;
 }
 
 int main() {
   make_graphs();
+  //   justCompile();
   check(checkSub(c5,petersen), "There should exist a C5->Petersen mapping.");
   check(!checkSub(c7,petersen),
Index: test/vf2pp_test.cc
===================================================================
--- test/vf2pp_test.cc	(revision 1186)
+++ test/vf2pp_test.cc	(revision 1186)
@@ -0,0 +1,392 @@
+/* -*- mode: C++; indent-tabs-mode: nil; -*-
+ *
+ * This file is a part of LEMON, a generic C++ optimization library.
+ *
+ * Copyright (C) 2015-2017
+ * EMAXA Kutato-fejleszto Kft. (EMAXA Research Ltd.)
+ *
+ * Permission to use, modify and distribute this software is granted
+ * provided that this copyright notice appears in all copies. For
+ * precise terms see the accompanying LICENSE file.
+ *
+ * This software is provided "AS IS" with no warranty of any kind,
+ * express or implied, and with no claim as to its suitability for any
+ * purpose.
+ *
+ */
+
+#include <lemon/vf2pp.h>
+#include <lemon/concepts/digraph.h>
+#include <lemon/smart_graph.h>
+#include <lemon/lgf_reader.h>
+#include <lemon/concepts/maps.h>
+#include <lemon/maps.h>
+#include <lemon/list_graph.h>
+
+#include <test/test_tools.h>
+#include <sstream>
+
+using namespace lemon;
+
+char petersen_lgf[] =
+  "@nodes\n"
+  "label col1 col2\n"
+  "0 1 1\n"
+  "1 1 2\n"
+  "2 1 3\n"
+  "3 1 4\n"
+  "4 2 5\n"
+  "5 2 1\n"
+  "6 2 2\n"
+  "7 2 3\n"
+  "8 2 4\n"
+  "9 2 5\n"
+  "@arcs\n"
+  "     -\n"
+  "0 1\n"
+  "1 2\n"
+  "2 3\n"
+  "3 4\n"
+  "4 0\n"
+  "0 5\n"
+  "1 6\n"
+  "2 7\n"
+  "3 8\n"
+  "4 9\n"
+  "5 8\n"
+  "5 7\n"
+  "9 6\n"
+  "9 7\n"
+  "6 8\n";
+
+char c5_lgf[] =
+  "@nodes\n"
+  "label col\n"
+  "0 1\n"
+  "1 2\n"
+  "2 3\n"
+  "3 4\n"
+  "4 5\n"
+  "@arcs\n"
+  "     -\n"
+  "0 1\n"
+  "1 2\n"
+  "2 3\n"
+  "3 4\n"
+  "4 0\n";
+
+char c7_lgf[] =
+  "@nodes\n"
+  "label\n"
+  "0\n"
+  "1\n"
+  "2\n"
+  "3\n"
+  "4\n"
+  "5\n"
+  "6\n"
+  "@arcs\n"
+  "     -\n"
+  "0 1\n"
+  "1 2\n"
+  "2 3\n"
+  "3 4\n"
+  "4 5\n"
+  "5 6\n"
+  "6 0\n";
+
+char c10_lgf[] =
+  "@nodes\n"
+  "label\n"
+  "0\n"
+  "1\n"
+  "2\n"
+  "3\n"
+  "4\n"
+  "5\n"
+  "6\n"
+  "7\n"
+  "8\n"
+  "9\n"
+  "@arcs\n"
+  "     -\n"
+  "0 1\n"
+  "1 2\n"
+  "2 3\n"
+  "3 4\n"
+  "4 5\n"
+  "5 6\n"
+  "6 7\n"
+  "7 8\n"
+  "8 9\n"
+  "9 0\n";
+
+char p10_lgf[] =
+  "@nodes\n"
+  "label\n"
+  "0\n"
+  "1\n"
+  "2\n"
+  "3\n"
+  "4\n"
+  "5\n"
+  "6\n"
+  "7\n"
+  "8\n"
+  "9\n"
+  "@arcs\n"
+  "     -\n"
+  "0 1\n"
+  "1 2\n"
+  "2 3\n"
+  "3 4\n"
+  "4 5\n"
+  "5 6\n"
+  "6 7\n"
+  "7 8\n"
+  "8 9\n";
+
+SmartGraph petersen, c5, c7, c10, p10;
+SmartGraph::NodeMap<int> petersen_col1(petersen);
+SmartGraph::NodeMap<int> petersen_col2(petersen);
+SmartGraph::NodeMap<int> c5_col(c5);
+
+void make_graphs(){
+  std::stringstream ss(petersen_lgf);
+  graphReader(petersen, ss)
+    .nodeMap("col1",petersen_col1)
+    .nodeMap("col2",petersen_col2)
+    .run();
+
+  ss.clear();
+  ss.str("");
+  ss<<c5_lgf;
+
+  graphReader(c5, ss)
+    .nodeMap("col",c5_col)
+    .run();
+
+  ss.clear();
+  ss.str("");
+  ss<<c7_lgf;
+  graphReader(c7, ss).run();
+
+  ss.clear();
+  ss.str("");
+  ss<<c10_lgf;
+  graphReader(c10, ss).run();
+
+  ss.clear();
+  ss.str("");
+  ss<<p10_lgf;
+  graphReader(p10, ss).run();
+
+}
+
+class IntConvertible1{
+public:
+  operator int(){
+    return 0;
+  }
+};
+
+class IntConvertible2{
+public:
+  operator int(){
+    return 0;
+  }
+};
+
+template<class G1,class G2>
+void checkVf2Compile() {
+  G1 g;
+  G2 h;
+  concepts::ReadWriteMap<typename G1::Node, typename G2::Node> r;
+  bool succ;
+  ::lemon::ignore_unused_variable_warning(succ);
+
+  succ = vf2pp(g,h).run();
+  succ = vf2pp(g,h).induced().run();
+  succ = vf2pp(g,h).iso().run();
+  succ = vf2pp(g,h).mapping(r).run();
+  succ = vf2pp(g,h).induced().mapping(r).run();
+  succ = vf2pp(g,h).iso().mapping(r).run();
+
+
+  concepts::ReadMap<typename G1::Node, int> c1;
+  concepts::ReadMap<typename G2::Node, int> c2;
+  Vf2pp<G1,G2,concepts::ReadWriteMap<typename G1::Node, typename G2::Node>,
+        concepts::ReadMap<typename G1::Node, int>,
+        concepts::ReadMap<typename G2::Node, int> >
+    myVf2pp(g,h,r,c1,c2);
+  myVf2pp.find();
+
+  succ = vf2pp(g,h).nodeLabels(c1,c2).mapping(r).run();
+  succ = vf2pp(g,h).nodeLabels(c1,c2)
+    .mapping(r).run();
+
+
+  concepts::ReadMap<typename G1::Node, char> c1_c;
+  concepts::ReadMap<typename G2::Node, char> c2_c;
+  Vf2pp<G1,G2,concepts::ReadWriteMap<typename G1::Node, typename G2::Node>,
+        concepts::ReadMap<typename G1::Node, char>,
+        concepts::ReadMap<typename G2::Node, char> >
+    myVf2pp_c(g,h,r,c1_c,c2_c);
+  myVf2pp_c.find();
+
+  succ = vf2pp(g,h).nodeLabels(c1_c,c2_c).mapping(r).run();
+  succ = vf2pp(g,h).nodeLabels(c1_c,c2_c)
+    .mapping(r).run();
+
+
+  concepts::ReadMap<typename G1::Node, IntConvertible1> c1_IntConv;
+  concepts::ReadMap<typename G2::Node, IntConvertible2> c2_IntConv;
+  Vf2pp<G1,G2,concepts::ReadWriteMap<typename G1::Node, typename G2::Node>,
+        concepts::ReadMap<typename G1::Node, IntConvertible1>,
+        concepts::ReadMap<typename G2::Node, IntConvertible2> >
+    myVf2pp_IntConv(g,h,r,c1_IntConv,c2_IntConv);
+  myVf2pp_IntConv.find();
+
+  succ = vf2pp(g,h).nodeLabels(c1_IntConv,c2_IntConv).mapping(r).run();
+  succ = vf2pp(g,h).nodeLabels(c1_IntConv,c2_IntConv)
+    .mapping(r).run();
+}
+
+void justCompile() {
+  checkVf2Compile<concepts::Graph,concepts::Graph>();
+  checkVf2Compile<concepts::Graph,SmartGraph>();
+  checkVf2Compile<SmartGraph,concepts::Graph>();
+}
+
+template<class G1, class G2, class I>
+void checkSub(const G1 &g1, const G2 &g2, const I &i) {
+  {
+    std::set<typename G2::Node> image;
+    for(typename G1::NodeIt n(g1);n!=INVALID;++n){
+      check(i[n]!=INVALID, "Wrong isomorphism: incomplete mapping.");
+      check(image.count(i[n])==0,"Wrong isomorphism: not injective.");
+      image.insert(i[n]);
+    }
+  }
+  for(typename G1::EdgeIt e(g1);e!=INVALID;++e)
+    check(findEdge(g2,i[g1.u(e)],i[g1.v(e)])!=INVALID,
+          "Wrong isomorphism: missing edge(checkSub).");
+}
+
+template<class G1, class G2, class I>
+void checkInd(const G1 &g1, const G2 &g2, const I &i) {
+  std::set<typename G2::Node> image;
+  for(typename G1::NodeIt n(g1);n!=INVALID;++n) {
+    check(i[n]!=INVALID, "Wrong isomorphism: incomplete mapping.");
+    check(image.count(i[n])==0,"Wrong isomorphism: not injective.");
+    image.insert(i[n]);
+  }
+  for(typename G1::NodeIt n(g1); n!=INVALID; ++n)
+    for(typename G1::NodeIt m(g1); m!=INVALID; ++m)
+      if((findEdge(g1,n,m)==INVALID) != (findEdge(g2,i[n],i[m])==INVALID)) {
+        std::cout << "Wrong isomorphism: edge mismatch";
+        exit(1);
+      }
+}
+
+template<class G1,class G2>
+int checkSub(const G1 &g1, const G2 &g2) {
+  typename G1:: template NodeMap<typename G2::Node> iso(g1,INVALID);
+  if(vf2pp(g1,g2).mapping(iso).run()){
+    checkSub(g1,g2,iso);
+    return true;
+  }
+  else
+    return false;
+}
+
+template<class G1,class G2>
+int checkInd(const G1 &g1, const G2 &g2) {
+  typename G1:: template NodeMap<typename G2::Node> iso(g1,INVALID);
+  if(vf2pp(g1,g2).induced().mapping(iso).run()) {
+    checkInd(g1,g2,iso);
+    return true;
+  }
+  else
+    return false;
+}
+
+template<class G1,class G2>
+int checkIso(const G1 &g1, const G2 &g2) {
+  typename G1:: template NodeMap<typename G2::Node> iso(g1,INVALID);
+  if(vf2pp(g1,g2).iso().mapping(iso).run()) {
+    check(countNodes(g1)==countNodes(g2),
+          "Wrong iso alg.: they are not isomophic.");
+    checkInd(g1,g2,iso);
+    return true;
+  }
+  else
+    return false;
+}
+
+template<class G1, class G2, class L1, class L2, class I>
+void checkLabel(const G1 &g1, const G2 &,
+                const L1 &l1, const L2 &l2,const I &i) {
+  for(typename G1::NodeIt n(g1);n!=INVALID;++n)
+    check(l1[n]==l2[i[n]],"Wrong isomorphism: label mismatch.");
+}
+
+template<class G1,class G2,class L1,class L2>
+int checkSub(const G1 &g1, const G2 &g2, const L1 &l1, const L2 &l2) {
+  typename G1:: template NodeMap<typename G2::Node> iso(g1,INVALID);
+  if(vf2pp(g1,g2).nodeLabels(l1,l2).mapping(iso).run()) {
+    checkSub(g1,g2,iso);
+    checkLabel(g1,g2,l1,l2,iso);
+    return true;
+  }
+  else
+    return false;
+}
+
+int main() {
+  make_graphs();
+//   justCompile();
+  check(checkSub(c5,petersen), "There should exist a C5->Petersen mapping.");
+  check(!checkSub(c7,petersen),
+        "There should not exist a C7->Petersen mapping.");
+  check(checkSub(p10,petersen), "There should exist a P10->Petersen mapping.");
+  check(!checkSub(c10,petersen),
+        "There should not exist a C10->Petersen mapping.");
+  check(checkSub(petersen,petersen),
+        "There should exist a Petersen->Petersen mapping.");
+
+  check(checkInd(c5,petersen),
+        "There should exist a C5->Petersen spanned mapping.");
+  check(!checkInd(c7,petersen),
+        "There should exist a C7->Petersen spanned mapping.");
+  check(!checkInd(p10,petersen),
+        "There should not exist a P10->Petersen spanned mapping.");
+  check(!checkInd(c10,petersen),
+        "There should not exist a C10->Petersen spanned mapping.");
+  check(checkInd(petersen,petersen),
+        "There should exist a Petersen->Petersen spanned mapping.");
+
+  check(!checkSub(petersen,c10),
+        "There should not exist a Petersen->C10 mapping.");
+  check(checkSub(p10,c10),
+        "There should exist a P10->C10 mapping.");
+  check(!checkInd(p10,c10),
+        "There should not exist a P10->C10 spanned mapping.");
+  check(!checkSub(c10,p10),
+        "There should not exist a C10->P10 mapping.");
+
+  check(!checkIso(p10,c10),
+        "P10 and C10 are not isomorphic.");
+  check(checkIso(c10,c10),
+        "C10 and C10 are isomorphic.");
+
+  check(!vf2pp(p10,c10).iso().run(),
+        "P10 and C10 are not isomorphic.");
+  check(vf2pp(c10,c10).iso().run(),
+        "C10 and C10 are isomorphic.");
+
+  check(!checkSub(c5,petersen,c5_col,petersen_col1),
+        "There should exist a C5->Petersen mapping.");
+  check(checkSub(c5,petersen,c5_col,petersen_col2),
+        "There should exist a C5->Petersen mapping.");
+}
Index: tools/dimacs-solver.cc
===================================================================
--- tools/dimacs-solver.cc	(revision 1170)
+++ tools/dimacs-solver.cc	(revision 1093)
@@ -223,5 +223,4 @@
         throw IoError("Cannot open the file for writing", ap.files()[1]);
       }
-      // fall through
     case 1:
       input.open(ap.files()[0].c_str());
@@ -229,5 +228,4 @@
         throw IoError("File cannot be found", ap.files()[0]);
       }
-      // fall through
     case 0:
       break;
@@ -254,5 +252,4 @@
         case DimacsDescriptor::SP:
           std::cout << "sp";
-          break;
         case DimacsDescriptor::MAT:
           std::cout << "mat";
Index: tools/dimacs-to-lgf.cc
===================================================================
--- tools/dimacs-to-lgf.cc	(revision 1179)
+++ tools/dimacs-to-lgf.cc	(revision 584)
@@ -74,5 +74,4 @@
         throw IoError("Cannot open the file for writing", ap.files()[1]);
       }
-      // fall through
     case 1:
       input.open(ap.files()[0].c_str());
@@ -80,5 +79,4 @@
         throw IoError("File cannot be found", ap.files()[0]);
       }
-      // fall through
     case 0:
       break;
